import sys,os
sys.path.append(os.path.abspath('../'))

from viiapackage import *
import numpy as np

project = viia_create_project('exercise-5-model')

project.read_dump("exercise5.json")

def rot(vector,theta):
    """
    Rotates 2-D vector around z-axis
    
    Input:
        axis (list): List of 2d coordinates that describe axis to be rotated.
        theta (float): angle in degrees to rotate around specified axis
    
    Output:
        matrix: rotated vector
    """
    theta=theta/180.0*np.pi    
    R = np.array([[np.cos(theta), -np.sin(theta)],[np.sin(theta), np.cos(theta)]])
    return np.dot(R,vector)

def rotation_matrix(axis, theta):
    """
    Return the rotation matrix associated with counterclockwise rotation about
    the given axis by theta radians.
    
    Input:
        axis (list): List of 3d coordinates that describe axis around which a vector needs to be rotated.
        theta (float): angle in dgerees to rotate around specified axis
    
    Output:
        matrix: rotational matrix
    
    """
    theta=theta/180.0*np.pi    
    axis = np.asarray(axis)
    axis = axis / np.sqrt(np.dot(axis, axis))
    a = np.cos(theta / 2.0)
    b, c, d = -axis * np.sin(theta / 2.0)
    aa, bb, cc, dd = a * a, b * b, c * c, d * d
    bc, ad, ac, ab, bd, cd = b * c, a * d, a * c, a * b, b * d, c * d
    return np.array([[aa + bb - cc - dd, 2 * (bc + ad), 2 * (bd - ac)],
                     [2 * (bc - ad), aa + cc - bb - dd, 2 * (cd + ab)],
                     [2 * (bd + ac), 2 * (cd - ab), aa + dd - bb - cc]])


roof_E = project.get_shape("roofs","N2-DAKEN-LIN-HBV-PLANKEN-0.018-0.1149-0.1149-0.6-1")
roof_F = project.get_shape("roofs","N2-DAKEN-LIN-HBV-PLANKEN-0.018-0.1149-0.1149-0.6-2")


### Write your solution here


#####

project.connect_all_shapes()

project.create_model(software="diana")
